Unit AMM7R_p;
interface
uses
SysUtils, Math, { Delphi }
LStruct, Lfunc;

procedure AMM7R(var A :Array of Real; N :Integer;
                var B :Array of Real; NC :Integer;
                var C :Array of Real); 
implementation

procedure AMM7R(var A :Array of Real; N :Integer;
                var B :Array of Real; NC :Integer;
                var C :Array of Real);
var
NCP1,NCP2,IRA,I,J,INDXA,IRB,JCB,JPTB,KAD,LEDZRO,K :Integer;
SUM :Real;
label
_5,_10,_15,_20,_25,_30,_35,_40;
begin
NCP1 := NC + 1;
NCP2 := NC + 2;
IRA := 1;
for J:=1 to N do
 begin
  for I:=1 to N do
   begin
    INDXA := IRA;
    IRB := I;
    JCB := Max0(NCP2-I,1);
    JPTB := 0;
    KAD := 1;
    LEDZRO := NCP2;
    SUM := 0.0;
    for K:=1 to N do
     begin
      if ( JCB = 0 ) 
       then goto _30;
      if ( K >= J ) 
       then KAD := K;
      if ( I < LEDZRO ) 
       then goto _5;
      LEDZRO := LEDZRO + 1;
      goto _20;
_5:
      SUM := SUM + A[INDXA-1] * B[(IRB-1)+(JCB-1)*N];
      if ( JPTB <> 0 ) 
       then goto _10;
      if ( JCB < NCP1 ) 
       then goto _15;
      JPTB := 1;
_10:
      JCB := JCB - 1;
      IRB := IRB + 1;
      goto _20;
_15:
      JCB := JCB + 1;
_20:
      INDXA := INDXA + KAD;
_25:
     end;
_30:
    C[(J-1)+(I-1)*N] := SUM;
_35:
   end;
  IRA := IRA + J;
_40:
 end;
end;

end.
